[Документация](../../README-ru.md#документация) → [Конфигурация](../config.ru.md) → Параметры мониторов

-----

[Read in English](monitor.en.md)

# Параметры мониторов

Данные параметры используются только мониторами Vitastor.

- [etcd_mon_ttl](#etcd_mon_ttl)
- [etcd_mon_timeout](#etcd_mon_timeout)
- [etcd_mon_retries](#etcd_mon_retries)
- [mon_change_timeout](#mon_change_timeout)
- [mon_stats_timeout](#mon_stats_timeout)
- [osd_out_time](#osd_out_time)
- [placement_levels](#placement_levels)
- [use_old_pg_combinator](#use_old_pg_combinator)

## etcd_mon_ttl

- Тип: секунды
- Значение по умолчанию: 1
- Минимальное значение: 5

Интервал обновления etcd резервации (lease) монитором

## etcd_mon_timeout

- Тип: миллисекунды
- Значение по умолчанию: 1000

Таймаут выполнения запросов к etcd от монитора

## etcd_mon_retries

- Тип: целое число
- Значение по умолчанию: 5

Максимальное число попыток выполнения запросов к etcd монитором

## mon_change_timeout

- Тип: миллисекунды
- Значение по умолчанию: 1000
- Минимальное значение: 100

Время повтора при коллизиях при запросах модификации в etcd, производимых монитором

## mon_stats_timeout

- Тип: миллисекунды
- Значение по умолчанию: 1000
- Минимальное значение: 100

Интервал, который монитор ожидает при изменении статистики по отдельным
OSD перед обновлением агрегированной статистики в etcd

## osd_out_time

- Тип: секунды
- Значение по умолчанию: 600

Время, через которое отключенный OSD исключается из распределения данных.
То есть, время, которое монитор ожидает перед попыткой переместить данные
на другие OSD и таким образом восстановить избыточность хранения.

## placement_levels

- Тип: json
- Значение по умолчанию: `{"host":100,"osd":101}`

Определения уровней для дерева размещения OSD. Вы можете определять
произвольные уровни, помещая их в данный параметр конфигурации. Значение
параметра должно содержать JSON-объект, ключи которого будут являться
названиями уровней, а значения - целочисленными приоритетами. Меньшие
приоритеты соответствуют верхним уровням дерева. Например, уровень
"датацентр" должен иметь меньший приоритет, чем "OSD". Уровни с названиями
"host" и "osd" являются предопределёнными и не могут быть удалены. Если
один из них отсутствует в конфигурации, он доопределяется с приоритетом по
умолчанию (100 для уровня "host", 101 для "osd").

## use_old_pg_combinator

- Тип: булево (да/нет)
- Значение по умолчанию: false

Использовать старый генератор комбинаций PG, не поддерживающий [level_placement](pool.ru.md#level_placement)
и [raw_placement](pool.ru.md#raw_placement) для пулов, которые не используют данные функции.
